/* Copyright (c) 2021 Jerry James
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
import java.io.FileWriter;
import java.io.IOException;
import scala.collection.immutable.Seq;

public class Generate {
  public static void main(String args[]) {
    Seq<GeneratedFile> files = codegen.genAll();
    for (int i = 0; i < files.length(); i++) {
      GeneratedFile gen = files.apply(i);
      try {
        FileWriter f = new FileWriter(args[0] + "/" + gen.name());
        f.write(gen.code());
        f.close();
      } catch (IOException e) {
        System.err.println("Failed to generate " + gen.name());
        System.err.println(e.toString());
        System.exit(1);
      }
    }
  }
}
